Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
glxGraphicsPipe Class Reference

This graphics pipe represents the interface for creating OpenGL graphics windows on an X-based (e.g. More...

`#include "glxGraphicsPipe.h"`

Inheritance diagram for glxGraphicsPipe:

## Public Member Functions
| glxGraphicsPipe (const std::string &display=std::string())
virtual TypeHandle | force_init_type ()
virtual std::string | get_interface_name () const
| Returns the name of the rendering interface associated with this GraphicsPipe.
virtual TypeHandle | get_type () const
Public Member Functions inherited from x11GraphicsPipe
| x11GraphicsPipe (const std::string &display=std::string())
void | disable_relative_mouse ()
| Disables relative mouse mode for this display.
bool | enable_relative_mouse ()
| Enables relative mouse mode for this display.
RRCrtc | find_fullscreen_crtc (const LPoint2i &point, int &x, int &y, int &width, int &height)
| Finds a CRTC for going fullscreen to, at the given origin.
std::unique_ptr< XRRCrtcInfo, pfn_XRRFreeCrtcInfo > | get_crtc_info (XRRScreenResources *res, RRCrtc crtc) const
| Returns an XRRCrtcInfo object, or null if RandR 1.2 is not supported.
X11_Display * | get_display () const
| Returns a pointer to the X display associated with the pipe: the display on which to create the windows.
X11_Cursor | get_hidden_cursor ()
| Returns an invisible Cursor suitable for assigning to windows that have the cursor_hidden property set.
XIM | get_im () const
| Returns the input method opened for the pipe, or NULL if the input method could not be opened for some reason.
virtual PreferredWindowThread | get_preferred_window_thread () const
| Returns an indication of the thread in which this GraphicsPipe requires its window processing to be performed: typically either the app thread (e.g.
X11_Window | get_root () const
| Returns the handle to the root window on the pipe's display.
int | get_screen () const
| Returns the X screen number associated with the pipe.
std::unique_ptr< XRRScreenResources, pfn_XRRFreeScreenResources > | get_screen_resources () const
| Returns an XRRScreenResources object, or null if RandR 1.2 is not supported.
bool | supports_relative_mouse () const
| Returns true if relative mouse mode is supported on this display.
Public Member Functions inherited from GraphicsPipe
GraphicsDevice * | get_device () const
| Returns a pointer to device object.
int | get_display_height () const
DisplayInformation * | get_display_information ()
int | get_display_width () const
PN_stdfloat | get_display_zoom () const
int | get_supported_types () const
| Returns the mask of bits that represents the kinds of GraphicsOutput objects this pipe might be able to successfully create.
bool | is_valid () const
| Returns false if this pipe is known to be invalid, meaning that an attempt to create a GraphicsWindow with the pipe will certainly fail.
virtual void | lookup_cpu_data ()
| Looks up the detailed CPU information and stores it in _display_information, if supported by the OS.
virtual | PT (GraphicsDevice) make_device(void *scrn
bool | supports_type (int flags) const
| A convenience function to ask if a particular type or types of GraphicsObjects are supported.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (GraphicsPipe) pipe_constructor()
Static Public Member Functions inherited from x11GraphicsPipe
static int | disable_x_error_messages ()
| Globally disables the printing of error messages that are raised by the X11 system, for instance in order to test whether a particular X11 operation will succeed.
static int | enable_x_error_messages ()
| Reenables the printing of error messages after a previous call to disable_x_error_messages().
static TypeHandle | get_class_type ()
static int | get_x_error_count ()
| Returns the number of times an error indication has been raised by the X11 system since application start, including errors raised while error messages were disabled.
static void | init_type ()
Static Public Member Functions inherited from GraphicsPipe
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from x11GraphicsPipe
typedef int(* | pfn_XcursorGetDefaultSize) (X11_Display *)
typedef XcursorImage *(* | pfn_XcursorImageCreate) (int, int)
typedef void(* | pfn_XcursorImageDestroy) (XcursorImage *)
typedef X11_Cursor(* | pfn_XcursorImageLoadCursor) (X11_Display *, const XcursorImage *)
typedef void(* | pfn_XcursorImagesDestroy) (XcursorImages *)
typedef X11_Cursor(* | pfn_XcursorImagesLoadCursor) (X11_Display *, const XcursorImages *)
typedef XcursorImages *(* | pfn_XcursorXcFileLoadImages) (XcursorFile *, int)
typedef SizeID(* | pfn_XRRConfigCurrentConfiguration) (XRRScreenConfiguration *, Rotation *)
typedef XRRScreenConfiguration *(* | pfn_XRRGetScreenInfo) (X11_Display *, X11_Window)
typedef Bool(* | pfn_XRRQueryExtension) (X11_Display *, int *, int *)
typedef Status(* | pfn_XRRQueryVersion) (X11_Display *, int *, int *)
typedef short *(* | pfn_XRRRates) (X11_Display *, int, int, int *)
typedef Status(* | pfn_XRRSetScreenConfig) (X11_Display *, XRRScreenConfiguration *, Drawable, int, Rotation, Time)
typedef XRRScreenSize *(* | pfn_XRRSizes) (X11_Display *, int, int *)
Public Types inherited from GraphicsPipe
enum | BufferCreationFlags { BF_refuse_parasite = 0x0001 , BF_require_parasite = 0x0002 , BF_refuse_window = 0x0004 , BF_require_window = 0x0008 , BF_require_callback_window = 0x0010 , BF_can_bind_color = 0x0040 , BF_can_bind_every = 0x0080 , BF_resizeable = 0x0100 , BF_size_track_host = 0x0200 , BF_rtt_cumulative = 0x0400 , BF_fb_props_optional = 0x0800 , BF_size_square = 0x1000 , BF_size_power_2 = 0x2000 , BF_can_bind_layered = 0x4000 }
enum | OutputTypes { OT_window = 0x0001 , OT_fullscreen_window = 0x0002 , OT_buffer = 0x0004 , OT_texture_buffer = 0x0008 }
enum | PreferredWindowThread { PWT_app , PWT_draw }
Public Attributes inherited from x11GraphicsPipe
bool | _have_xrandr
Atom | _net_wm_bypass_compositor
Atom | _net_wm_name
Atom | _net_wm_pid
Atom | _net_wm_state
Atom | _net_wm_state_above
Atom | _net_wm_state_add
Atom | _net_wm_state_below
Atom | _net_wm_state_fullscreen
Atom | _net_wm_state_remove
Atom | _net_wm_window_type
Atom | _net_wm_window_type_fullscreen
Atom | _net_wm_window_type_splash
Atom | _wm_delete_window
int | _xcursor_size
pfn_XcursorImageCreate | _XcursorImageCreate
pfn_XcursorImageDestroy | _XcursorImageDestroy
pfn_XcursorImageLoadCursor | _XcursorImageLoadCursor
pfn_XcursorImagesDestroy | _XcursorImagesDestroy
pfn_XcursorImagesLoadCursor | _XcursorImagesLoadCursor
pfn_XcursorXcFileLoadImages | _XcursorXcFileLoadImages
pfn_XRRConfigCurrentConfiguration | _XRRConfigCurrentConfiguration
pfn_XRRGetScreenInfo | _XRRGetScreenInfo
pfn_XRRRates | _XRRRates
pfn_XRRSetScreenConfig | _XRRSetScreenConfig
pfn_XRRSizes | _XRRSizes
Public Attributes inherited from GraphicsPipe
| get_display_height
| Returns the height of the entire display, if it is known.
| get_display_information
| Gets the pipe's DisplayInformation.
| get_display_width
| Returns the width of the entire display, if it is known.
| get_display_zoom
| Returns the display zoom factor configured in the operating system.
| get_interface_name
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Static Public Attributes inherited from x11GraphicsPipe
static LightReMutex | _x_mutex

## Detailed Description

This graphics pipe represents the interface for creating OpenGL graphics windows on an X-based (e.g.

Unix) client.

Definition at line 76 of file glxGraphicsPipe.h.

## Constructor & Destructor Documentation

## ◆ glxGraphicsPipe()

glxGraphicsPipe::glxGraphicsPipe | ( | const std::string & | display = std::string() | ) |

Definition at line 30 of file glxGraphicsPipe.cxx.

## ◆ ~glxGraphicsPipe()

virtual glxGraphicsPipe::~glxGraphicsPipe | ( |  | ) |
| inline virtual

Definition at line 79 of file glxGraphicsPipe.h.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle glxGraphicsPipe::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from x11GraphicsPipe.

Definition at line 108 of file glxGraphicsPipe.h.

## ◆ get_class_type()

static TypeHandle glxGraphicsPipe::get_class_type | ( |  | ) |
| inline static

Definition at line 97 of file glxGraphicsPipe.h.

## ◆ get_interface_name()

string glxGraphicsPipe::get_interface_name | ( |  | ) | const
| virtual

Returns the name of the rendering interface associated with this GraphicsPipe.

This is used to present to the user to allow him/her to choose between several possible GraphicsPipes available on a particular platform, so the name should be meaningful and unique for a given platform.

Implements GraphicsPipe.

Definition at line 54 of file glxGraphicsPipe.cxx.

## ◆ get_type()

virtual TypeHandle glxGraphicsPipe::get_type | ( |  | ) | const
| inline virtual

Reimplemented from x11GraphicsPipe.

Definition at line 105 of file glxGraphicsPipe.h.

## ◆ init_type()

static void glxGraphicsPipe::init_type | ( |  | ) |
| inline static

Definition at line 100 of file glxGraphicsPipe.h.

The documentation for this class was generated from the following files:

- panda/src/glxdisplay/glxGraphicsPipe.h
- panda/src/glxdisplay/glxGraphicsPipe.cxx